;;; -*- Mode: LISP; Syntax: Common-lisp;  -*-

(in-package qpe::*user-package*)

(adb::rules-file "IR-TEST")

;;;; Special domain to test influence resolution code.

;; Modeled after the Chicago city government

(defQuantity-Type resources individual)
(defQuantity-Type payoff individual)
(defQuantity-Type taxes individual)
(defQuantity-Type Bank-balance individual)

(defentity Person
	   (Quantity (bank-balance ?self)))

(defentity Taxpayer
	   (person ?self)
	   (honest ?self))

(defentity Alderman
	   (person ?self))

(defentity Government
	   (quantity (resources ?self)))

(defview (broke ?gov)
	 Individuals ((?gov :type government))
	 QuantityConditions ((less-than (A (resources ?gov)) zero)))

(defview (surplus ?gov)
	 Individuals ((?gov :type government))
	 QuantityConditions ((greater-than (A (resources ?gov)) zero)))

(defprocess (Graft ?ald ?gov)
  ;; Model of corruption as constant drain.
	    Individuals ((?gov :type government)
			 (?ald :type alderman
			       :conditions (has-alderman ?gov ?ald))
			 (?surp :conditions (View-Instance surplus ?surp ?gov)))
	    QuantityConditions ((Active ?surp))
	    Relations ((quantity payoff)
		       (greater-than (A payoff) zero))
	    Influences ((I- (resources ?gov) (A payoff))
			(I+ (bank-balance ?ald) (A payoff))))

(defprocess (Taxation ?sap ?gov)
	    Individuals ((?gov :type government)
			 (?sap :type person
			       :conditions (honest ?sap)))
	    Relations ((quantity taxes)
		       (greater-than (A taxes) zero) ;; no NIT.
		       (Qprop- taxes (resources ?gov)))
	    Influences ((I+ (resources ?gov) (A taxes))
			(I- (bank-balance ?sap) (A taxes))))