;;; -*- Mode: LISP; Syntax: Common-lisp; -*-

(in-package qpe::*user-package*)

(adb::rules-file "IR-TEST3")

;;;; IR-TEST3 domain

;; Inverted model of the Chicago city government -- rates are all
;; negative.

(defQuantity-Type debits individual)
(defQuantity-Type payoff individual)
(defQuantity-Type taxes individual)
(defQuantity-Type Bank-balance individual)

(defentity Person
	   (Quantity (bank-balance ?self)))

(defentity Taxpayer
	   (person ?self)
	   (honest ?self))

(defentity Alderman
	   (person ?self))

(defentity Government
	   (quantity (debits ?self)))

(defview (broke ?gov)
	 Individuals ((?gov :type government))
	 QuantityConditions ((greater-than (A (debits ?gov)) zero)))

(defview (surplus ?gov)
	 Individuals ((?gov :type government))
	 QuantityConditions ((less-than (A (debits ?gov)) zero)))

(defprocess (Graft ?ald ?gov)
  ;; Model of corruption as constant drain.
	    Individuals ((?gov :type government)
			 (?ald :type alderman
			       :conditions (has-alderman ?gov ?ald))
			 (?surp :conditions (View-Instance surplus ?surp ?gov)))
	    QuantityConditions ((Active ?surp))
	    Relations ((quantity payoff)
		       (less-than (A payoff) zero))
	    Influences ((I+ (debits ?gov) (A payoff))
			(I- (bank-balance ?ald) (A payoff))))

(defprocess (Taxation ?sap ?gov)
	    Individuals ((?gov :type government)
			 (?sap :type person
			       :conditions (honest ?sap)))
	    Relations ((quantity taxes)
		       (less-than (A taxes) zero)
		       (Qprop taxes (debits ?gov)))
	    Influences ((I- (debits ?gov) (A taxes))
			(I+ (bank-balance ?sap) (A taxes))))
