;;; -*- Mode: LISP; Syntax: Common-lisp; -*-

(in-package qpe::*user-package*)

(adb::rules-file "IR-TEST4")

;;;; IR-TEST4 domain

;;; Puts together some abstract quantities to check 
;;   code which varies signs of rates.

(defQuantity-Type zorch individual)
(defQuantity-Type kick individual)

(defentity Thing
	   (Quantity (zorch ?self)))

(defentity Port)

(defprocess (Prod+ ?th ?pt)
    ;; A thing can be prodded through a port.
    ;; However, we remain agnostic about the nature of the effect.
    Individuals ((?th :type thing)
		 (?pt :type port
		      :conditions (has-P-port ?th ?pt)))
    Relations ((quantity kick)
	       (greater-than (A kick) zero))
	    Influences ((I+ (zorch ?th) (A kick))))

(defprocess (Prod- ?th ?pt)
    ;; A thing can be prodded through a port.
    ;; However, we remain agnostic about the nature of the effect.
    Individuals ((?th :type thing)
		 (?pt :type port
		      :conditions (has-N-port ?th ?pt)))
    Relations ((quantity kick)
	       (less-than (A kick) zero))
	    Influences ((I+ (zorch ?th) (A kick))))
